import six
from ipywidgets import Widget, DOMWidget, widget_serialization, Color, register
from traitlets import (
    Unicode, Int, CInt, Instance, ForwardDeclaredInstance, This, Enum,
    Tuple, List, Dict, Float, CFloat, Bool, Union, Any,
    )

from .tileLayer import tileLayer


@register
class osmLayer(tileLayer):
    """osmLayer

    Autogenerated by generate-wrappers.js
    """

    def __init__(self, map_id='', **kwargs):
        kwargs['map_id'] = map_id
        super(osmLayer, self).__init__(**kwargs)

    _model_name = Unicode('osmLayerModel').tag(sync=True)

    mapOpacity = CFloat(None, allow_none=True, min=0, max=1).tag(sync=True)


if six.PY3:
    import inspect
    # Include explicit signature since the metaclass screws it up
    osmLayer.__signature__ = inspect.signature(osmLayer.__init__)
